/* $Workfile: Dsp55Demo2Io.h $   $Revision: 7 $    $Modtime: 3/24/04 8:56a $  */
#ifndef DSP55_DEMO2_IO_H
#define DSP55_DEMO2_IO_H
/*--------------------------------------------------------------------------*\

  Odin TeleSystems Inc.

  SAA-1007-1 OTX DSP C5000 Software Development Kit (SDK)

  IOCLT Codes and Structs for communication between the DSP code and the
  DSP55DEMO2 user application

\*--------------------------------------------------------------------------*/


/*******************************************************************************
  @devnote
   DSP IOCTL codes.
*******************************************************************************/

#define DEMO2_IOCTL_SET_TX_GAIN       0x0100
#define DEMO2_IOCTL_GET_SAMPLE        0x0101
#define DEMO2_IOCTL_GET_DEBUG_DATA    0x0102
#define DEMO2_IOCTL_STREAM_RX_DATA    0x0103
#define DEMO2_IOCTL_CONTROL_LED       0x0104
#define DEMO2_IOCTL_TEST_EXTERNAL_MEM 0x0105
#define DEMO2_IOCTL_LOOP_ALL_TS       0x0106
#define DEMO2_IOCTL_GET_FULL_FRAME    0x0107

/*******************************************************************************
  @devnote
   DSP Notify Event codes.
*******************************************************************************/

#define DEMO2_NOTIFY_DEBUG_DATA       0x0200
#define DEMO2_NOTIFY_STREAM_RX_DATA   0x0201

/*******************************************************************************
  @devnote
   Structs for passing data over the DSP IOCTL interface
*******************************************************************************/


// Fix packing for IO Control Structs
#if defined(__linux__) 
#pragma pack(2)
#elif defined(_TMS320C5XX)
// No pack pragma needed for the DSP compiler
#elif defined(__TMS320C55X__)
// No pack pragma needed for the DSP compiler
#elif defined(__BORLANDC__)
#pragma option push -a2
#else
#pragma pack(push,2)
#endif

// Structs used in calls to OtxDspIoControl()
typedef struct Demo2IoInSetTxGainS
{
  short        nTxGain;
} Demo2IoInSetTxGainS;

typedef struct Demo2IoInStreamRxDataS
{
  short        bStreamRxData;
} Demo2IoInStreamRxDataS;

typedef struct Demo2IoInLoopAllTsS
{
  short        bLoopAllTs;
} Demo2IoInLoopAllTsS;

typedef struct Demo2IoInControlLedS
{
  short        nLed;
  short        bOn;
} Demo2IoInControlLedS;

typedef struct Demo2IoOutTestExternalMemS
{ 
  unsigned short        nResult;
  
  unsigned short        nDataErrorsLowWord;
  unsigned short        nDataErrorsHighWord;
  unsigned short        nMemErrorsLowWord;
  unsigned short        nMemErrorsHighWord;  
} Demo2IoOutTestExternalMemS;

typedef struct Demo2IoOutGetSampleS
{
  unsigned short        nResult;
  unsigned short        nDataSample;
} Demo2IoOutGetSampleS;

typedef struct Demo2IoOutGetFullFrameS
{
  unsigned short        nResult;
  unsigned short        nFrame[128];
} Demo2IoOutGetFullFrameS;


// Structs used for Notify Events
typedef struct Demo2NotifyGetDebugDataS
{
  unsigned short        nData0;
  unsigned short        nData1;
  unsigned short        nData2;
  unsigned short        nData3;
  unsigned short        nData4;
  unsigned short        nData5;
  unsigned short        nData6;
  unsigned short        nData7;
  unsigned short        sqBuf[32];
} Demo2NotifyGetDebugDataS;

typedef struct Demo2NotifyStreamRxDataS
{
  unsigned short        nData[25];
} Demo2NotifyStreamRxDataS;


#if defined(__linux__) 
#pragma pack(2)
#elif defined(_TMS320C5XX)
// No pack pragma needed for the DSP compiler
#elif defined(__TMS320C55X__)
// No pack pragma needed for the DSP compiler
#elif defined(__BORLANDC__)
#pragma option pop
#else
#pragma pack(pop)
#endif



#endif  // DSP55_DEMO2_IO_H
